//
//  EthernetMacViewController.m
//  P52NDemo
//
//  Created by mac on 2020/11/30.
//

#import "EthernetMacViewController.h"
#import <P52NSDK/P52NSDK.h>
#import <SVProgressHUD/SVProgressHUD.h>

@interface EthernetMacViewController ()<AsP52NDelegate>
@property (strong, nonatomic) IBOutlet UITextField *macTextField;
@end

@implementation EthernetMacViewController
{
    AsP52N *asP52N;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.macTextField.userInteractionEnabled = NO;
    asP52N = [AsP52N sharedInstance];
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:YES];
    asP52N.delegate = self;
    [self performSelector:@selector(dismissHUD) withObject:nil afterDelay:10];
    [SVProgressHUD showWithStatus:@"Ethernet Mac"];
    [asP52N getReaderEthernetMacAddress];
}
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:YES];
    asP52N.delegate = nil;
}
#pragma mark - AsP52NDelegate
- (void)AsP52N:(AsP52N *)AsP52N receivedReaderEthernetMACAddress:(NSString *)ethernetMACAddress {
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(dismissHUD) object:nil];
    [SVProgressHUD dismiss];
    self.macTextField.text = ethernetMACAddress;
}
- (void)AsP52N:(AsP52N *)AsP52N changeNetworkState:(AsP52NetworkState)state error:(NSError *)error {
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        if (state != AsP52NetworkStateConnected) {
            [self.navigationController popToRootViewControllerAnimated:YES];
        }
    }];
}
#pragma mark - Private
- (void)dismissHUD {
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        [SVProgressHUD dismiss];
    }];
}
@end
