//
//  AntPowerViewController.m
//  P52NDemo
//
//  Created by mac on 2020/11/25.
//

#import "AntPowerViewController.h"
#import <SVProgressHUD/SVProgressHUD.h>
#import <P52NSDK/P52NSDK.h>
#import "System.h"
#import "Utils.h"
@interface AntPowerViewController ()<UITextFieldDelegate, AsP52NDelegate>
@property (strong, nonatomic) IBOutlet UITextField *ant1TextField;
@property (strong, nonatomic) IBOutlet UITextField *ant2TextField;
@property (strong, nonatomic) IBOutlet UITextField *ant3TextField;
@property (strong, nonatomic) IBOutlet UITextField *ant4TextField;
@property (strong, nonatomic) IBOutlet UITextField *ant5TextField;
@property (strong, nonatomic) IBOutlet UITextField *ant6TextField;
@property (strong, nonatomic) IBOutlet UITextField *ant7TextField;
@property (strong, nonatomic) IBOutlet UITextField *ant8TextField;
@end

@implementation AntPowerViewController
{
    AsP52N *asP52N;
    System *system;
    int ant1Power;
    int ant2Power;
    int ant3Power;
    int ant4Power;
    int ant5Power;
    int ant6Power;
    int ant7Power;
    int ant8Power;
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:YES];
    asP52N.delegate = self;
    [self performSelector:@selector(dismissHUD) withObject:nil afterDelay:10];
    [SVProgressHUD showWithStatus:@"Antenna power"];
    [asP52N getReaderAntennaPower];
}
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:YES];
    asP52N.delegate = nil;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    system = [System sharedSystem];
    asP52N = [AsP52N sharedInstance];
    self.tableView.tableFooterView = [[UIView alloc] initWithFrame:CGRectZero];
}
#pragma mark - Action
- (IBAction)onClickDoneBarItem:(UIBarButtonItem *)sender {
    [self.tableView endEditing:YES];
    [self performSelector:@selector(dismissHUD) withObject:nil afterDelay:10];
    [SVProgressHUD showWithStatus:@"Set antenna power"];
    [asP52N setReaderAntenna1Power:ant1Power antenna2Power:ant2Power antenna3Power:ant3Power antenna4Power:ant4Power antenna5Power:ant5Power antenna6Power:ant6Power antenna7Power:ant7Power antenna8Power:ant8Power];
}
#pragma mark - UITextFieldDelegate
- (void)textFieldDidEndEditing:(UITextField *)textField {
    if (textField == self.ant1TextField) {
        ant1Power = [self.ant1TextField.text intValue];
    } else if (textField == self.ant2TextField) {
        ant2Power = [self.ant2TextField.text intValue];
    } else if (textField == self.ant3TextField) {
        ant3Power = [self.ant3TextField.text intValue];
    } else if (textField == self.ant4TextField) {
        ant4Power = [self.ant4TextField.text intValue];
    } else if (textField == self.ant5TextField) {
        ant5Power = [self.ant5TextField.text intValue];
    } else if (textField == self.ant6TextField) {
        ant6Power = [self.ant6TextField.text intValue];
    } else if (textField == self.ant7TextField) {
        ant7Power = [self.ant7TextField.text intValue];
    } else if (textField == self.ant8TextField) {
        ant8Power = [self.ant8TextField.text intValue];
    }
}
- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string {
    if ([[textField.text stringByAppendingString:string] intValue] >=0 && [[textField.text stringByAppendingString:string] intValue] <= 36) {
        return YES;
    } else {
        return NO;
    }
}
#pragma mark - UITableViewDelegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [self.tableView endEditing:YES];
}
#pragma mark - AsP52NDelegate
- (void)AsP52N:(AsP52N *)AsP52N receivedReaderAntenna1Power:(int)antenna1Power antenna2Power:(int)antenna2Power antenna3Power:(int)antenna3Power antenna4Power:(int)antenna4Power antenna5Power:(int)antenna5Power antenna6Power:(int)antenna6Power antenna7Power:(int)antenna7Power antenna8Power:(int)antenna8Power {
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(dismissHUD) object:nil];
    [SVProgressHUD dismiss];
    self.ant1TextField.text = [NSString stringWithFormat:@"%d", antenna1Power];
    self.ant2TextField.text = [NSString stringWithFormat:@"%d", antenna2Power];
    self.ant3TextField.text = [NSString stringWithFormat:@"%d", antenna3Power];
    self.ant4TextField.text = [NSString stringWithFormat:@"%d", antenna4Power];
    self.ant5TextField.text = [NSString stringWithFormat:@"%d", antenna5Power];
    self.ant6TextField.text = [NSString stringWithFormat:@"%d", antenna6Power];
    self.ant7TextField.text = [NSString stringWithFormat:@"%d", antenna7Power];
    self.ant8TextField.text = [NSString stringWithFormat:@"%d", antenna8Power];
    ant1Power = antenna1Power;
    ant2Power = antenna2Power;
    ant3Power = antenna3Power;
    ant4Power = antenna4Power;
    ant5Power = antenna5Power;
    ant6Power = antenna6Power;
    ant7Power = antenna7Power;
    ant8Power = antenna8Power;
}
- (void)AsP52N:(AsP52N *)AsP52N receivedSetAntennaPowerStatus:(AsP52NExecutionStatus)statusCode {
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(dismissHUD) object:nil];
    [SVProgressHUD dismiss];
    NSString *failedString = [asP52N getMessageWithResultCode:statusCode];
    [Utils showAlert:@"" message:failedString];
}
- (void)AsP52N:(AsP52N *)AsP52N changeNetworkState:(AsP52NetworkState)state error:(NSError *)error {
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        if (state != AsP52NetworkStateConnected) {
            [self.navigationController popToRootViewControllerAnimated:YES];
        }
    }];
}
#pragma mark - Private
- (void)dismissHUD {
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        [SVProgressHUD dismiss];
    }];
}
@end
