//
//  InventoryTypeViewController.m
//  P52NDemo
//
//  Created by mac on 2020/12/2.
//

#import "InventoryTypeViewController.h"
#import <P52NSDK/P52NSDK.h>
#import "System.h"
@interface InventoryTypeViewController ()<AsP52NDelegate>

@end

@implementation InventoryTypeViewController
{
    AsP52N *asP52N;
    System *_system;
    NSInteger _selected;
    NSArray *dataArray;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    _system = [System sharedSystem];
    asP52N = [AsP52N sharedInstance];
    _selected = [_system getInventoryType];
    dataArray = [NSArray arrayWithObjects:@"EPC", @"TID", @"USER", @"Moisture", @"MagnusS3", nil];
    self.tableView.tableFooterView = [[UIView alloc] initWithFrame:CGRectZero];
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:YES];
    asP52N.delegate = self;
}
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:YES];
    asP52N.delegate = nil;
}
- (IBAction)onClickDoneBarItem:(UIBarButtonItem *)sender {
    [_system setInventoryType:_selected];
    if (_delegate && [_delegate respondsToSelector:@selector(whenInventoryType)]) {
        [_delegate whenInventoryType];
    }
    [self.navigationController popViewControllerAnimated:YES];
}
#pragma mark - Table view data source
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return dataArray.count;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"tableViewCell"];
    if (!cell){
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:@"tableViewCell"];
    }
    NSString *string = [dataArray objectAtIndex:indexPath.row];
    cell.textLabel.text = string;
    if (_selected == indexPath.row) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    } else {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    return cell;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    _selected = indexPath.row;
    [self.tableView reloadData];
}
#pragma mark - AsP52NDelegate
- (void)AsP52N:(AsP52N *)AsP52N changeNetworkState:(AsP52NetworkState)state error:(NSError *)error {
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        if (state != AsP52NetworkStateConnected) {
            [self.navigationController popToRootViewControllerAnimated:YES];
        }
    }];
}
@end
