//
//  MaskViewController.m
//  P52NDemo
//
//  Created by Songxueqian on 2023/2/1.
//

#import "MaskViewController.h"
#import <P52NSDK/P52NSDK.h>
#import "System.h"

@interface MaskViewController ()
@property (strong, nonatomic) IBOutlet UISegmentedControl *typeSegment;
@property (strong, nonatomic) IBOutlet UITextView *dataTextView;
@property (strong, nonatomic) IBOutlet UITextField *addressTextField;
@end

@implementation MaskViewController
{
    AsP52NMemoryBankType memoryBankType;
    System *_system;
    int address;
    NSString *data;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    _system = [System sharedSystem];
    self.typeSegment.selectedSegmentIndex = _system.getMaskType.intValue;
    self.dataTextView.text = _system.getMaskData;
    self.addressTextField.text = _system.getMaskAddress;
    self.dataTextView.layer.masksToBounds = YES;
    self.dataTextView.layer.borderColor = [[UIColor lightGrayColor] CGColor];
    self.dataTextView.layer.borderWidth = 1;
    self.dataTextView.layer.cornerRadius = 5;
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(viewBack)];
    [self.view addGestureRecognizer:tap];
}
#pragma mark - Action
- (IBAction)onClickTypeSegment:(UISegmentedControl *)sender {
    switch (sender.selectedSegmentIndex) {
        case 0:
        {
            memoryBankType = AsP52NMemoryBankTypeReserved;
           
        }
            break;
        case 1:
        {
            memoryBankType = AsP52NMemoryBankTypeEPC;
            
        }
            break;
        case 2:
        {
            memoryBankType =AsP52NMemoryBankTypeTID;
            
        }
            break;
        case 3:
        {
            memoryBankType = AsP52NMemoryBankTypeUser;
           
        }
            break;
        default:
            break;
    }
}
- (IBAction)onClickBarItemDone:(UIBarButtonItem *)sender {
    [_system setMaskType:[NSString stringWithFormat:@"%ld", (long)self.typeSegment.selectedSegmentIndex]];
    [_system setMaskData:self.dataTextView.text];
    [_system setMaskAddress:self.addressTextField.text];
    [self.navigationController popViewControllerAnimated:YES];
}
#pragma mark - Private
- (void)viewBack {
    [self.view endEditing:YES];
}
@end
