//
//  RFIDSettingViewController.m
//  P52NDemo
//
//  Created by mac on 2020/11/30.
//

#import "RFIDSettingViewController.h"
#import "InventoryTypeViewController.h"
#import <P52NSDK/P52NSDK.h>
#import "SysSwitchCell.h"
#import "TextFieldCell.h"
#import "System.h"

@interface RFIDSettingViewController ()<AsP52NDelegate, UITableViewDelegate, UITableViewDataSource, SysSwitchCellDelegate, InventoryTypeDelegate>
@property (weak, nonatomic) IBOutlet UITableView *tableView;
@end

@implementation RFIDSettingViewController
{
    AsP52N *asP52N;
    System *system;
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:YES];
    asP52N.delegate = self;
}
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:YES];
    asP52N.delegate = nil;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    system = [System sharedSystem];
    asP52N = [AsP52N sharedInstance];
    self.tableView.tableFooterView = [[UIView alloc] initWithFrame:CGRectZero];
}
#pragma mark - Table view data source
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 8;
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 45.f;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    if (indexPath.row == 0) {
        NSString *cellIdentifier = @"SysSwitchCell";
        SysSwitchCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        if(!cell) {
            cell = [[[NSBundle mainBundle] loadNibNamed:@"SysSwitchCell" owner:self options:nil] firstObject];
        }
        cell.delegate = self;
        cell.titleLabel.text = @"ContinueScan";
        cell.sysSwitch.on = [system getIsContinueScan];
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.accessoryType = UITableViewCellAccessoryNone;
        return cell;
    } else if (indexPath.row == 1) {
        NSString *cellIdentifier = @"TextFieldCell";
        TextFieldCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        if(!cell) {
            cell = [[[NSBundle mainBundle] loadNibNamed:@"TextFieldCell" owner:self options:nil] firstObject];
        }
        cell.titleLabel.text = @"Inventory Type";
        cell.valueLabel.text = [self enumChangeString];
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        return cell;
    } else if (indexPath.row == 2) {
        NSString *cellIdentifier = @"tableViewCell";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        if(!cell){
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
        }
        cell.textLabel.text = @"Antennas";
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        return cell;
    } else if (indexPath.row == 3) {
        NSString *cellIdentifier = @"tableViewCell";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        if(!cell){
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
        }
        cell.textLabel.text = @"Base band";
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        return cell;
    } else if (indexPath.row == 4) {
        NSString *cellIdentifier = @"tableViewCell";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        if(!cell){
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
        }
        cell.textLabel.text = @"Auto dormancy";
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        return cell;
    } else if (indexPath.row == 5) {
        NSString *cellIdentifier = @"tableViewCell";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        if(!cell){
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
        }
        cell.textLabel.text = @"Frequency list";
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        return cell;
    } else if (indexPath.row == 6) {
        NSString *cellIdentifier = @"tableViewCell";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        if(!cell){
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
        }
        cell.textLabel.text = @"Filter";
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        return cell;
    } else {
        NSString *cellIdentifier = @"tableViewCell";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
        if(!cell){
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:cellIdentifier];
        }
        cell.textLabel.text = @"Mask";
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        return cell;
    }
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    if (indexPath.row == 1) {
        [self performSegueWithIdentifier:@"TypeID" sender:nil];
    } else if (indexPath.row == 2) {
        [self performSegueWithIdentifier:@"AntennasID" sender:nil];
    } else if (indexPath.row == 3) {
        [self performSegueWithIdentifier:@"BaseBandID" sender:nil];
    } else if (indexPath.row == 4) {
        [self performSegueWithIdentifier:@"AutoDormancyID" sender:nil];
    } else if (indexPath.row == 5) {
        [self performSegueWithIdentifier:@"FrequencyListID" sender:nil];
    } else if (indexPath.row == 6) {
        [self performSegueWithIdentifier:@"TagLogID" sender:nil];
    } else if (indexPath.row == 7) {
        [self performSegueWithIdentifier:@"MaskID" sender:nil];
    }
}
#pragma mark - SwitchDelegate
- (void)whenClickSysSwitch:(UISwitch *)cell {
    SysSwitchCell *sysCell = (SysSwitchCell *)cell;
    [system setIsContinueScan:sysCell.sysSwitch.isOn];
    [self.tableView reloadData];
}
#pragma mark - InventoryTypeDelegate
- (void)whenInventoryType {
    [self.tableView reloadData];
}
#pragma mark - AsP52NDelegate
- (void)AsP52N:(AsP52N *)AsP52N changeNetworkState:(AsP52NetworkState)state error:(NSError *)error {
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        if (state != AsP52NetworkStateConnected) {
            [self.navigationController popToRootViewControllerAnimated:YES];
        }
    }];
}
#pragma mark - Private
- (NSString *)enumChangeString {
    NSString *string = @"";
    switch ([system getInventoryType]) {
        case 0:
        {
            string = @"EPC";
        }
            break;
        case 1:
        {
            string = @"TID";
        }
            break;
        case 2:
        {
            string = @"USER";
        }
            break;
        case 3:
        {
            string = @"Moisture";
        }
            break;
        case 4:
        {
            string = @"MagnusS3";
        }
            break;
//        case 5:
//        {
//            string = @"Ltu31";
//        }
//            break;
//        case 6:
//        {
//            string = @"Ltu27";
//        }
//            break;
//        case 7:
//        {
//            string = @"NMV2D";
//        }
//        case 8:
//        {
//            string = @"Custom";
//        }
        default:
            break;
    }
    return  string;
}
#pragma mark - System
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    if ([segue.identifier isEqualToString:@"TypeID"]) {
        InventoryTypeViewController *inventoryTypeVC = segue.destinationViewController;
        inventoryTypeVC.delegate = self;
    }
}
@end
