//
//  DataListController.m
//  P52NDemo
//
//  Created by mac on 2020/12/8.
//

#import "DataListController.h"
#import "ReadViewController.h"
#import "WriteViewController.h"
#import "LockViewController.h"
#import "KillViewController.h"
#import <P52NSDK/P52NSDK.h>

@interface DataListController ()<AsP52NDelegate>

@end

@implementation DataListController
{
    AsP52N *asP52N;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.tableView.tableFooterView = [[UIView alloc] initWithFrame:CGRectZero];
    asP52N = [AsP52N sharedInstance];
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:YES];
    asP52N.delegate = self;
}
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:YES];
    asP52N.delegate = nil;
}
#pragma mark - UITableViewDelegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    if (indexPath.row == 0) {
        [self performSegueWithIdentifier:@"ReadID" sender:nil];
    } else if (indexPath.row == 1) {
        [self performSegueWithIdentifier:@"WriteID" sender:nil];
    } else if (indexPath.row == 2) {
        [self performSegueWithIdentifier:@"LockID" sender:nil];
    } else if (indexPath.row == 3) {
        [self performSegueWithIdentifier:@"KillID" sender:nil];
    }
}
#pragma mark - AsP52NDelegate
- (void)AsP52N:(AsP52N *)AsP52N changeNetworkState:(AsP52NetworkState)state error:(NSError *)error {
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
        if (state != AsP52NetworkStateConnected) {
            [self.navigationController popToRootViewControllerAnimated:YES];
        }
    }];
}
#pragma mark - Navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    if ([segue.identifier isEqualToString:@"ReadID"]) {
        ReadViewController *readVC = segue.destinationViewController;
        readVC.epcData = _epcData;
    } else if ([segue.identifier isEqualToString:@"WriteID"]) {
        WriteViewController *customVC = segue.destinationViewController;
        customVC.epcData = _epcData;
    } else if ([segue.identifier isEqualToString:@"LockID"]) {
        LockViewController *customVC = segue.destinationViewController;
        customVC.epcData = _epcData;
    } else if ([segue.identifier isEqualToString:@"KillID"]) {
        KillViewController *customVC = segue.destinationViewController;
        customVC.epcData = _epcData;
    }
}
@end
