//
//  System.m
//
//  Created by mac on 2018/12/20.
//  Copyright © 2018年 zyl. All rights reserved.
//

#import "System.h"
@implementation System{
    NSUserDefaults *_userDefaults;
}
static System * _sharedSystem;
+ (System *)sharedSystem{
    if (!_sharedSystem) {
        _sharedSystem = [[System alloc] init];
    }
    return _sharedSystem;
}
- (instancetype)init
{
    self = [super init];
    if (self) {
        _userDefaults = [NSUserDefaults standardUserDefaults];
        if (![self getIsFirstUsed]) {
            [self setIsFirstUsed:@"YES"];
            [self setPort:@"8160"];
            [self setStopTime:@"10"];
            [self setIsContinueScan:YES];
            [self setAnt1Status:YES];
            [self setAnt2Status:YES];
            [self setAnt3Status:YES];
            [self setAnt4Status:YES];
            [self setAnt5Status:YES];
            [self setAnt6Status:YES];
            [self setAnt7Status:YES];
            [self setAnt8Status:YES];
            [self setInventoryType:InventoryTypeEPC];
            [self setMaskType:@"0"];
            [self setMaskData:@""];
            [self setMaskAddress:@"0"];
        }
    }
    return self;
}
- (void)setIsFirstUsed:(NSString *)used{
    [_userDefaults setValue:used forKey:@"isFirstUsed"];
    [_userDefaults synchronize];
}
- (NSString *)getIsFirstUsed{
    return  [_userDefaults valueForKey:@"isFirstUsed"];
}
- (void)setIp:(NSString *)ip{
    [_userDefaults setValue:ip forKey:@"ip"];
    [_userDefaults synchronize];
}
- (NSString *)getIp{
    return [_userDefaults valueForKey:@"ip"]?:@"";
}
- (void)setPort:(NSString *)port{
    [_userDefaults setValue:port forKey:@"port"];
    [_userDefaults synchronize];
}
- (NSString *)getPort{
    return [_userDefaults valueForKey:@"port"]?:@"";
}
- (void)setStopTime:(NSString *)time{
    [_userDefaults setValue:time forKey:@"time"];
    [_userDefaults synchronize];
}
- (NSString *)getStopTime{
    return [_userDefaults valueForKey:@"time"]?:@"";
}
- (BOOL)getIsContinueScan{
    return [_userDefaults boolForKey:@"isContinueScan"];
}
- (void)setIsContinueScan:(BOOL)isContinueScan{
    [_userDefaults setBool:isContinueScan forKey:@"isContinueScan"];
    [_userDefaults synchronize];
}
- (InventoryType)getInventoryType{
    return [_userDefaults integerForKey:@"inventoryType"];
}
- (void)setInventoryType:(InventoryType)inventoryType{
    [_userDefaults setInteger:inventoryType forKey:@"inventoryType"];
    [_userDefaults synchronize];
}
- (void)setAnt1Status:(BOOL)antStatus{
    [_userDefaults setBool:antStatus forKey:@"ant1"];
    [_userDefaults synchronize];
}
- (void)setAnt2Status:(BOOL)antStatus{
    [_userDefaults setBool:antStatus forKey:@"ant2"];
    [_userDefaults synchronize];
}
- (void)setAnt3Status:(BOOL)antStatus{
    [_userDefaults setBool:antStatus forKey:@"ant3"];
    [_userDefaults synchronize];
}
- (void)setAnt4Status:(BOOL)antStatus{
    [_userDefaults setBool:antStatus forKey:@"ant4"];
    [_userDefaults synchronize];
}
- (void)setAnt5Status:(BOOL)antStatus{
    [_userDefaults setBool:antStatus forKey:@"ant5"];
    [_userDefaults synchronize];
}
- (void)setAnt6Status:(BOOL)antStatus{
    [_userDefaults setBool:antStatus forKey:@"ant6"];
    [_userDefaults synchronize];
}
- (void)setAnt7Status:(BOOL)antStatus{
    [_userDefaults setBool:antStatus forKey:@"ant7"];
    [_userDefaults synchronize];
}
- (void)setAnt8Status:(BOOL)antStatus{
    [_userDefaults setBool:antStatus forKey:@"ant8"];
    [_userDefaults synchronize];
}
- (BOOL)getAnt1Status{
    return  [_userDefaults boolForKey:@"ant1"];
}
- (BOOL)getAnt2Status{
    return  [_userDefaults boolForKey:@"ant2"];
}
- (BOOL)getAnt3Status{
    return  [_userDefaults boolForKey:@"ant3"];
}
- (BOOL)getAnt4Status{
    return  [_userDefaults boolForKey:@"ant4"];
}
- (BOOL)getAnt5Status{
    return  [_userDefaults boolForKey:@"ant5"];
}
- (BOOL)getAnt6Status{
    return  [_userDefaults boolForKey:@"ant6"];
}
- (BOOL)getAnt7Status{
    return  [_userDefaults boolForKey:@"ant7"];
}
- (BOOL)getAnt8Status{
    return  [_userDefaults boolForKey:@"ant8"];
}
- (void)setMaskType:(NSString *)type{
    [_userDefaults setObject:type forKey:@"masktype"];
    [_userDefaults synchronize];
}
- (NSString *)getMaskType{
    return [_userDefaults objectForKey:@"masktype"];
}
- (void)setMaskAddress:(NSString *)address{
    [_userDefaults setObject:address forKey:@"maskaddress"];
    [_userDefaults synchronize];
}
- (NSString *)getMaskAddress{
    return [_userDefaults objectForKey:@"maskaddress"];
}
- (void)setMaskData:(NSString *)data{
    [_userDefaults setObject:data forKey:@"maskData"];
    [_userDefaults synchronize];
}
- (NSString *)getMaskData{
    return  [_userDefaults objectForKey:@"maskData"];
}
@end
